//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: cryptoorg/nft/v1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query defines the gRPC querier service for NFT module
///
/// Usage: instantiate `Chainmain_Nft_V1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Chainmain_Nft_V1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Chainmain_Nft_V1_QueryClientInterceptorFactoryProtocol? { get }

  func supply(
    _ request: Chainmain_Nft_V1_QuerySupplyRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Chainmain_Nft_V1_QuerySupplyRequest, Chainmain_Nft_V1_QuerySupplyResponse>

  func owner(
    _ request: Chainmain_Nft_V1_QueryOwnerRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Chainmain_Nft_V1_QueryOwnerRequest, Chainmain_Nft_V1_QueryOwnerResponse>

  func collection(
    _ request: Chainmain_Nft_V1_QueryCollectionRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Chainmain_Nft_V1_QueryCollectionRequest, Chainmain_Nft_V1_QueryCollectionResponse>

  func denom(
    _ request: Chainmain_Nft_V1_QueryDenomRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Chainmain_Nft_V1_QueryDenomRequest, Chainmain_Nft_V1_QueryDenomResponse>

  func denomByName(
    _ request: Chainmain_Nft_V1_QueryDenomByNameRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Chainmain_Nft_V1_QueryDenomByNameRequest, Chainmain_Nft_V1_QueryDenomByNameResponse>

  func denoms(
    _ request: Chainmain_Nft_V1_QueryDenomsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Chainmain_Nft_V1_QueryDenomsRequest, Chainmain_Nft_V1_QueryDenomsResponse>

  func nFT(
    _ request: Chainmain_Nft_V1_QueryNFTRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Chainmain_Nft_V1_QueryNFTRequest, Chainmain_Nft_V1_QueryNFTResponse>
}

extension Chainmain_Nft_V1_QueryClientProtocol {
  internal var serviceName: String {
    return "chainmain.nft.v1.Query"
  }

  /// Supply queries the total supply of a given denom or owner
  ///
  /// - Parameters:
  ///   - request: Request to send to Supply.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func supply(
    _ request: Chainmain_Nft_V1_QuerySupplyRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Chainmain_Nft_V1_QuerySupplyRequest, Chainmain_Nft_V1_QuerySupplyResponse> {
    return self.makeUnaryCall(
      path: "/chainmain.nft.v1.Query/Supply",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeSupplyInterceptors() ?? []
    )
  }

  /// Owner queries the NFTs of the specified owner
  ///
  /// - Parameters:
  ///   - request: Request to send to Owner.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func owner(
    _ request: Chainmain_Nft_V1_QueryOwnerRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Chainmain_Nft_V1_QueryOwnerRequest, Chainmain_Nft_V1_QueryOwnerResponse> {
    return self.makeUnaryCall(
      path: "/chainmain.nft.v1.Query/Owner",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeOwnerInterceptors() ?? []
    )
  }

  /// Collection queries the NFTs of the specified denom
  ///
  /// - Parameters:
  ///   - request: Request to send to Collection.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func collection(
    _ request: Chainmain_Nft_V1_QueryCollectionRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Chainmain_Nft_V1_QueryCollectionRequest, Chainmain_Nft_V1_QueryCollectionResponse> {
    return self.makeUnaryCall(
      path: "/chainmain.nft.v1.Query/Collection",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeCollectionInterceptors() ?? []
    )
  }

  /// Denom queries the definition of a given denom
  ///
  /// - Parameters:
  ///   - request: Request to send to Denom.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func denom(
    _ request: Chainmain_Nft_V1_QueryDenomRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Chainmain_Nft_V1_QueryDenomRequest, Chainmain_Nft_V1_QueryDenomResponse> {
    return self.makeUnaryCall(
      path: "/chainmain.nft.v1.Query/Denom",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeDenomInterceptors() ?? []
    )
  }

  /// DenomByName queries the definition of a given denom by name
  ///
  /// - Parameters:
  ///   - request: Request to send to DenomByName.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func denomByName(
    _ request: Chainmain_Nft_V1_QueryDenomByNameRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Chainmain_Nft_V1_QueryDenomByNameRequest, Chainmain_Nft_V1_QueryDenomByNameResponse> {
    return self.makeUnaryCall(
      path: "/chainmain.nft.v1.Query/DenomByName",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeDenomByNameInterceptors() ?? []
    )
  }

  /// Denoms queries all the denoms
  ///
  /// - Parameters:
  ///   - request: Request to send to Denoms.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func denoms(
    _ request: Chainmain_Nft_V1_QueryDenomsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Chainmain_Nft_V1_QueryDenomsRequest, Chainmain_Nft_V1_QueryDenomsResponse> {
    return self.makeUnaryCall(
      path: "/chainmain.nft.v1.Query/Denoms",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeDenomsInterceptors() ?? []
    )
  }

  /// NFT queries the NFT for the given denom and token ID
  ///
  /// - Parameters:
  ///   - request: Request to send to NFT.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func nFT(
    _ request: Chainmain_Nft_V1_QueryNFTRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Chainmain_Nft_V1_QueryNFTRequest, Chainmain_Nft_V1_QueryNFTResponse> {
    return self.makeUnaryCall(
      path: "/chainmain.nft.v1.Query/NFT",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeNFTInterceptors() ?? []
    )
  }
}

internal protocol Chainmain_Nft_V1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'supply'.
  func makeSupplyInterceptors() -> [ClientInterceptor<Chainmain_Nft_V1_QuerySupplyRequest, Chainmain_Nft_V1_QuerySupplyResponse>]

  /// - Returns: Interceptors to use when invoking 'owner'.
  func makeOwnerInterceptors() -> [ClientInterceptor<Chainmain_Nft_V1_QueryOwnerRequest, Chainmain_Nft_V1_QueryOwnerResponse>]

  /// - Returns: Interceptors to use when invoking 'collection'.
  func makeCollectionInterceptors() -> [ClientInterceptor<Chainmain_Nft_V1_QueryCollectionRequest, Chainmain_Nft_V1_QueryCollectionResponse>]

  /// - Returns: Interceptors to use when invoking 'denom'.
  func makeDenomInterceptors() -> [ClientInterceptor<Chainmain_Nft_V1_QueryDenomRequest, Chainmain_Nft_V1_QueryDenomResponse>]

  /// - Returns: Interceptors to use when invoking 'denomByName'.
  func makeDenomByNameInterceptors() -> [ClientInterceptor<Chainmain_Nft_V1_QueryDenomByNameRequest, Chainmain_Nft_V1_QueryDenomByNameResponse>]

  /// - Returns: Interceptors to use when invoking 'denoms'.
  func makeDenomsInterceptors() -> [ClientInterceptor<Chainmain_Nft_V1_QueryDenomsRequest, Chainmain_Nft_V1_QueryDenomsResponse>]

  /// - Returns: Interceptors to use when invoking 'nFT'.
  func makeNFTInterceptors() -> [ClientInterceptor<Chainmain_Nft_V1_QueryNFTRequest, Chainmain_Nft_V1_QueryNFTResponse>]
}

internal final class Chainmain_Nft_V1_QueryClient: Chainmain_Nft_V1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Chainmain_Nft_V1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the chainmain.nft.v1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Chainmain_Nft_V1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query defines the gRPC querier service for NFT module
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Chainmain_Nft_V1_QueryProvider: CallHandlerProvider {
  var interceptors: Chainmain_Nft_V1_QueryServerInterceptorFactoryProtocol? { get }

  /// Supply queries the total supply of a given denom or owner
  func supply(request: Chainmain_Nft_V1_QuerySupplyRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Chainmain_Nft_V1_QuerySupplyResponse>

  /// Owner queries the NFTs of the specified owner
  func owner(request: Chainmain_Nft_V1_QueryOwnerRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Chainmain_Nft_V1_QueryOwnerResponse>

  /// Collection queries the NFTs of the specified denom
  func collection(request: Chainmain_Nft_V1_QueryCollectionRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Chainmain_Nft_V1_QueryCollectionResponse>

  /// Denom queries the definition of a given denom
  func denom(request: Chainmain_Nft_V1_QueryDenomRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Chainmain_Nft_V1_QueryDenomResponse>

  /// DenomByName queries the definition of a given denom by name
  func denomByName(request: Chainmain_Nft_V1_QueryDenomByNameRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Chainmain_Nft_V1_QueryDenomByNameResponse>

  /// Denoms queries all the denoms
  func denoms(request: Chainmain_Nft_V1_QueryDenomsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Chainmain_Nft_V1_QueryDenomsResponse>

  /// NFT queries the NFT for the given denom and token ID
  func nFT(request: Chainmain_Nft_V1_QueryNFTRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Chainmain_Nft_V1_QueryNFTResponse>
}

extension Chainmain_Nft_V1_QueryProvider {
  internal var serviceName: Substring { return "chainmain.nft.v1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "Supply":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Chainmain_Nft_V1_QuerySupplyRequest>(),
        responseSerializer: ProtobufSerializer<Chainmain_Nft_V1_QuerySupplyResponse>(),
        interceptors: self.interceptors?.makeSupplyInterceptors() ?? [],
        userFunction: self.supply(request:context:)
      )

    case "Owner":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Chainmain_Nft_V1_QueryOwnerRequest>(),
        responseSerializer: ProtobufSerializer<Chainmain_Nft_V1_QueryOwnerResponse>(),
        interceptors: self.interceptors?.makeOwnerInterceptors() ?? [],
        userFunction: self.owner(request:context:)
      )

    case "Collection":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Chainmain_Nft_V1_QueryCollectionRequest>(),
        responseSerializer: ProtobufSerializer<Chainmain_Nft_V1_QueryCollectionResponse>(),
        interceptors: self.interceptors?.makeCollectionInterceptors() ?? [],
        userFunction: self.collection(request:context:)
      )

    case "Denom":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Chainmain_Nft_V1_QueryDenomRequest>(),
        responseSerializer: ProtobufSerializer<Chainmain_Nft_V1_QueryDenomResponse>(),
        interceptors: self.interceptors?.makeDenomInterceptors() ?? [],
        userFunction: self.denom(request:context:)
      )

    case "DenomByName":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Chainmain_Nft_V1_QueryDenomByNameRequest>(),
        responseSerializer: ProtobufSerializer<Chainmain_Nft_V1_QueryDenomByNameResponse>(),
        interceptors: self.interceptors?.makeDenomByNameInterceptors() ?? [],
        userFunction: self.denomByName(request:context:)
      )

    case "Denoms":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Chainmain_Nft_V1_QueryDenomsRequest>(),
        responseSerializer: ProtobufSerializer<Chainmain_Nft_V1_QueryDenomsResponse>(),
        interceptors: self.interceptors?.makeDenomsInterceptors() ?? [],
        userFunction: self.denoms(request:context:)
      )

    case "NFT":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Chainmain_Nft_V1_QueryNFTRequest>(),
        responseSerializer: ProtobufSerializer<Chainmain_Nft_V1_QueryNFTResponse>(),
        interceptors: self.interceptors?.makeNFTInterceptors() ?? [],
        userFunction: self.nFT(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Chainmain_Nft_V1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'supply'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeSupplyInterceptors() -> [ServerInterceptor<Chainmain_Nft_V1_QuerySupplyRequest, Chainmain_Nft_V1_QuerySupplyResponse>]

  /// - Returns: Interceptors to use when handling 'owner'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeOwnerInterceptors() -> [ServerInterceptor<Chainmain_Nft_V1_QueryOwnerRequest, Chainmain_Nft_V1_QueryOwnerResponse>]

  /// - Returns: Interceptors to use when handling 'collection'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeCollectionInterceptors() -> [ServerInterceptor<Chainmain_Nft_V1_QueryCollectionRequest, Chainmain_Nft_V1_QueryCollectionResponse>]

  /// - Returns: Interceptors to use when handling 'denom'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeDenomInterceptors() -> [ServerInterceptor<Chainmain_Nft_V1_QueryDenomRequest, Chainmain_Nft_V1_QueryDenomResponse>]

  /// - Returns: Interceptors to use when handling 'denomByName'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeDenomByNameInterceptors() -> [ServerInterceptor<Chainmain_Nft_V1_QueryDenomByNameRequest, Chainmain_Nft_V1_QueryDenomByNameResponse>]

  /// - Returns: Interceptors to use when handling 'denoms'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeDenomsInterceptors() -> [ServerInterceptor<Chainmain_Nft_V1_QueryDenomsRequest, Chainmain_Nft_V1_QueryDenomsResponse>]

  /// - Returns: Interceptors to use when handling 'nFT'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeNFTInterceptors() -> [ServerInterceptor<Chainmain_Nft_V1_QueryNFTRequest, Chainmain_Nft_V1_QueryNFTResponse>]
}
